///////////////////////////////////////////////////
//	Declare the CWnDrv Multi Thread Image Comparison and
//  Some Definations Used by CWnDrv 
///////////////////////////////////////////////////
#ifndef __CWnDrv_H__
#define __CWnDrv_H__

#include "BtEnum.h"

#define m_lImgWid   (DWORD)m_pDIBHdr->bmiHeader.biWidth 
#define m_lImgHei   (DWORD)m_pDIBHdr->bmiHeader.biHeight
#define m_lVImgSize m_pDIBHdr->bmiHeader.biSizeImage 
#define ALLOC(a,b,c) { a  = (b*)malloc( c ); if( !a) { PRINTF( "Can't alloc memory "); }}
#define FREE(a) { if(a){ free(a) ; a =NULL ; }}


class CWnDrv : public CObject
{
public:
	CWnDrv(CWnd* pWnd,WORD  wHWCardNo,
		   BYTE* lpImage,
		   BITMAPINFO* lpDIBHdr);
	virtual ~CWnDrv();

public:
	WORD m_wHWCurrentCardNum ;
    DWORD  m_DatProcMilliSecond; 

	BOOL CreateThread( DWORD dwCreateFlags = 0, 
		               UINT nStackSize = 0, 
					   LPSECURITY_ATTRIBUTES lpSecurityAttrs = NULL );
	DWORD ResumeThread();
	DWORD SuspendThread();
	void KillThread();

	void wnwd_SetCmpStepXY( WORD wStepX ,WORD wStepY );
	void wnwd_SetCmpStepYUV(BYTE cStepY ,BYTE cStepU,BYTE cStepV );
	void wnwd_SetCmpPercent( double dPercent );
	BOOL wnwd_SaveBMP(char *FileName);
	BOOL wnwd_GetCmpStatus();

	void wnwd_IsSetting();
	void wnwd_IsSave(BOOL bIsSave) ;
	void wnwd_IsWarn(BOOL bIsWarn) ;
private:
	//  private Data Definition
    HANDLE m_hDatProcThread; 
	BITMAPINFO *m_pDIBHdr;
	BYTE *m_pBtImage ; 
	BYTE *m_pBtImageBak ; 
	int  m_iVGABits   ;
	BOOL m_bIsSave , m_bIsWarn , m_WarnStatus;
	BYTE *m_pYUVSample, *m_pYUV;
	WORD m_wStepX, m_wStepY ;
	BYTE m_cStepY, m_cStepU, m_cStepV ;
	double m_dPercent ;DWORD m_lYUVSize,m_lYUVSampleSize ;

	//  private Function Definition
	static void DatProcThreadInitialProc(LPVOID pv) 
	{
		CWnDrv * pThis = (CWnDrv*) pv; 
		pThis->DatProcThreadProc();
    };

	BOOL wnwd_SystemInit (WORD wHWCurrentCardNum,
					  BYTE* lpImage,
			          BITMAPINFO* lpDIBHdr) ;
	void wnwd_SystemFinish();

	void wnwd_CmpInit();
    
	void DatProcThreadProc(void);

	void wnwd_ChangeRGBtoYUV( unsigned char R, 
                          unsigned char G,
						  unsigned char B,
						  unsigned char *Y,
						  unsigned char *U,
						  unsigned char *V) ;
	void wnwd_ChangeYUVtoRGB( unsigned char Y, 
                          unsigned char U, 
						  unsigned char V, 
						  unsigned char *R, 
						  unsigned char *G, 
						  unsigned char *B) ;
	void wnwd_RGB15_toYUV(  BYTE *lpRGB, BYTE *lpYUV,
	                    DWORD wWidth , DWORD wHeight ,
				        WORD wStepX  , WORD wStepY ) ;
	void wnwd_RGB16_toYUV(  BYTE *lpRGB, BYTE *lpYUV,
	                    DWORD wWidth , DWORD wHeight ,
				        WORD wStepX  , WORD wStepY ) ;
	void wnwd_RGB24_toYUV(  BYTE *lpRGB, BYTE *lpYUV,
	                    DWORD wWidth , DWORD wHeight ,
				        WORD wStepX  , WORD wStepY ) ;
	void wnwd_RGB32_toYUV(  BYTE *lpRGB, BYTE *lpYUV,
	                    DWORD wWidth , DWORD wHeight ,
				        WORD wStepX  , WORD wStepY ) ;

	BOOL wnwd_VImgIsMotify();
};
#endif // __CWnDrv_H__
